// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_call(f, o, args) { return f.apply(o, args.slice(1)); }
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_on_ie () {
  var ua = window.navigator?window.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _g__(_pM_,_pN_,_pO_,_pP_,_pQ_,_pR_,_pS_)
     {return _pM_.length==6
              ?_pM_(_pN_,_pO_,_pP_,_pQ_,_pR_,_pS_)
              :caml_call_gen(_pM_,[_pN_,_pO_,_pP_,_pQ_,_pR_,_pS_]);}
    function _cS_(_pI_,_pJ_,_pK_,_pL_)
     {return _pI_.length==3
              ?_pI_(_pJ_,_pK_,_pL_)
              :caml_call_gen(_pI_,[_pJ_,_pK_,_pL_]);}
    function _dl_(_pF_,_pG_,_pH_)
     {return _pF_.length==2?_pF_(_pG_,_pH_):caml_call_gen(_pF_,[_pG_,_pH_]);}
    function _a__(_pD_,_pE_)
     {return _pD_.length==1?_pD_(_pE_):caml_call_gen(_pD_,[_pE_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Not_found")],
     _d_=[0,new MlString("Assert_failure")];
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _aS_=new MlString("%.12g"),
     _aR_=new MlString("."),
     _aQ_=new MlString("%d"),
     _aP_=new MlString("true"),
     _aO_=new MlString("false"),
     _aN_=new MlString("Pervasives.do_at_exit"),
     _aM_=new MlString("\\b"),
     _aL_=new MlString("\\t"),
     _aK_=new MlString("\\n"),
     _aJ_=new MlString("\\r"),
     _aI_=new MlString("\\\\"),
     _aH_=new MlString("\\'"),
     _aG_=new MlString("String.contains_from"),
     _aF_=new MlString("String.blit"),
     _aE_=new MlString("String.sub"),
     _aD_=new MlString("Buffer.add: cannot grow buffer"),
     _aC_=new MlString(""),
     _aB_=new MlString(""),
     _aA_=new MlString("\""),
     _az_=new MlString("\""),
     _ay_=new MlString("'"),
     _ax_=new MlString("'"),
     _aw_=new MlString("."),
     _av_=new MlString("printf: bad positional specification (0)."),
     _au_=new MlString("%_"),
     _at_=[0,new MlString("printf.ml"),144,8],
     _as_=new MlString("''"),
     _ar_=new MlString("Printf: premature end of format string ``"),
     _aq_=new MlString("''"),
     _ap_=new MlString(" in format string ``"),
     _ao_=new MlString(", at char number "),
     _an_=new MlString("Printf: bad conversion %"),
     _am_=new MlString("Sformat.index_of_int: negative argument "),
     _al_=new MlString("x"),
     _ak_=new MlString("OCAMLRUNPARAM"),
     _aj_=new MlString("CAMLRUNPARAM"),
     _ai_=new MlString(""),
     _ah_=[0,new MlString("src/core/lwt.ml"),573,20],
     _ag_=[0,new MlString("src/core/lwt.ml"),575,8],
     _af_=[0,new MlString("src/core/lwt.ml"),440,20],
     _ae_=[0,new MlString("src/core/lwt.ml"),443,8],
     _ad_=new MlString("Lwt.fast_connect"),
     _ac_=new MlString("Lwt.connect"),
     _ab_=new MlString("Lwt.wakeup"),
     _aa_=new MlString("Lwt.Canceled"),
     _$_=new MlString("on"),
     ___=new MlString("canvas"),
     _Z_=new MlString("img"),
     _Y_=new MlString("br"),
     _X_=new MlString("p"),
     _W_=new MlString("div"),
     _V_=new MlString("label"),
     _U_=new MlString("input"),
     _T_=new MlString("select"),
     _S_=new MlString("option"),
     _R_=new MlString("\""),
     _Q_=new MlString(" name=\""),
     _P_=new MlString("\""),
     _O_=new MlString(" type=\""),
     _N_=new MlString("<"),
     _M_=new MlString(">"),
     _L_=new MlString(""),
     _K_=new MlString("mouseup"),
     _J_=new MlString("mousemove"),
     _I_=new MlString("2d"),
     _H_=new MlString("Dom_html.Canvas_not_available"),
     _G_=new MlString("lighter"),
     _F_=new MlString("copy"),
     _E_=new MlString("% 2.f"),
     _D_=new MlString(""),
     _C_=new MlString("controls"),
     _B_=new MlString("Click and drag mouse to rotate."),
     _A_=new MlString("Resume"),
     _z_=new MlString("Pause"),
     _y_=new MlString("Fixed position"),
     _x_=new MlString("Follow rotation"),
     _w_=new MlString("Reset orientation"),
     _v_=new MlString("Date:"),
     _u_=
      [0,
       new MlString("December solstice"),
       [0,new MlString("Equinox"),[0,new MlString("June solstice"),0]]],
     _t_=new MlString("Lighting"),
     _s_=new MlString("Clip"),
     _r_=new MlString("Frames per second: "),
     _q_=
      new
       MlString
       ("Credit: <a href='http://visibleearth.nasa.gov/'>Visual Earth</a>, Nasa"),
     _p_=[0,new MlString("planet.ml"),415,0],
     _o_=[0,new MlString("planet.ml"),416,0],
     _n_=[0,new MlString("planet.ml"),417,0],
     _m_=[0,new MlString("planet.ml"),418,0],
     _l_=new MlString("copy"),
     _k_=new MlString("checkbox"),
     _j_=new MlString("button"),
     v_i_=[254,0,0,1],
     _h_=new MlString("../planet/texture.jpg");
    function _g_(s_e_){throw [0,_a_,s_e_];}
    function _aT_(s_f_){throw [0,_b_,s_f_];}
    function _a4_(s1_aU_,s2_aW_)
     {var
       l1_aV_=s1_aU_.getLen(),
       l2_aX_=s2_aW_.getLen(),
       s_aY_=caml_create_string(l1_aV_+l2_aX_|0);
      caml_blit_string(s1_aU_,0,s_aY_,0,l1_aV_);
      caml_blit_string(s2_aW_,0,s_aY_,l1_aV_,l2_aX_);
      return s_aY_;}
    function string_of_int_a5_(n_aZ_){return caml_format_int(_aQ_,n_aZ_);}
    function do_at_exit_a6_(param_a3_)
     {var param_a0_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_a0_)
         {var l_a1_=param_a0_[2];
          try {}catch(_a2_){}
          var param_a0_=l_a1_;
          continue;}
        return 0;}}
    caml_register_named_value(_aN_,do_at_exit_a6_);
    function _be_(f_a9_,a_a7_)
     {var l_a8_=a_a7_.length-1;
      if(0===l_a8_)return [0];
      var
       r_a$_=caml_make_vect(l_a8_,_a__(f_a9_,a_a7_[0+1])),
       _ba_=1,
       _bb_=l_a8_-1|0;
      if(!(_bb_<_ba_))
       {var i_bc_=_ba_;
        for(;;)
         {r_a$_[i_bc_+1]=_a__(f_a9_,a_a7_[i_bc_+1]);
          var _bd_=i_bc_+1|0;
          if(_bb_!==i_bc_){var i_bc_=_bd_;continue;}
          break;}}
      return r_a$_;}
    function _br_(n_bf_,c_bh_)
     {var s_bg_=caml_create_string(n_bf_);
      caml_fill_string(s_bg_,0,n_bf_,c_bh_);
      return s_bg_;}
    function _bs_(s_bk_,ofs_bi_,len_bj_)
     {if(0<=ofs_bi_&&0<=len_bj_&&!((s_bk_.getLen()-len_bj_|0)<ofs_bi_))
       {var r_bl_=caml_create_string(len_bj_);
        caml_blit_string(s_bk_,ofs_bi_,r_bl_,0,len_bj_);
        return r_bl_;}
      return _aT_(_aE_);}
    function _bt_(s1_bo_,ofs1_bn_,s2_bq_,ofs2_bp_,len_bm_)
     {if
       (0<=
        len_bm_&&
        0<=
        ofs1_bn_&&
        !((s1_bo_.getLen()-len_bm_|0)<ofs1_bn_)&&
        0<=
        ofs2_bp_&&
        !((s2_bq_.getLen()-len_bm_|0)<ofs2_bp_))
       return caml_blit_string(s1_bo_,ofs1_bn_,s2_bq_,ofs2_bp_,len_bm_);
      return _aT_(_aF_);}
    var
     _bu_=caml_sys_get_config(0)[2],
     _bv_=caml_mul(_bu_/8|0,(1<<(_bu_-10|0))-1|0)-1|0;
    function _bN_(n_bw_)
     {var
       n_bx_=1<=n_bw_?n_bw_:1,
       n_by_=_bv_<n_bx_?_bv_:n_bx_,
       s_bz_=caml_create_string(n_by_);
      return [0,s_bz_,0,n_by_,s_bz_];}
    function _bO_(b_bA_){return _bs_(b_bA_[1],0,b_bA_[2]);}
    function _bH_(b_bB_,more_bD_)
     {var new_len_bC_=[0,b_bB_[3]];
      for(;;)
       {if(new_len_bC_[1]<(b_bB_[2]+more_bD_|0))
         {new_len_bC_[1]=2*new_len_bC_[1]|0;continue;}
        if(_bv_<new_len_bC_[1])
         if((b_bB_[2]+more_bD_|0)<=_bv_)new_len_bC_[1]=_bv_;else _g_(_aD_);
        var new_buffer_bE_=caml_create_string(new_len_bC_[1]);
        _bt_(b_bB_[1],0,new_buffer_bE_,0,b_bB_[2]);
        b_bB_[1]=new_buffer_bE_;
        b_bB_[3]=new_len_bC_[1];
        return 0;}}
    function _bP_(b_bF_,c_bI_)
     {var pos_bG_=b_bF_[2];
      if(b_bF_[3]<=pos_bG_)_bH_(b_bF_,1);
      b_bF_[1].safeSet(pos_bG_,c_bI_);
      b_bF_[2]=pos_bG_+1|0;
      return 0;}
    function _bQ_(b_bL_,s_bJ_)
     {var len_bK_=s_bJ_.getLen(),new_position_bM_=b_bL_[2]+len_bK_|0;
      if(b_bL_[3]<new_position_bM_)_bH_(b_bL_,len_bK_);
      _bt_(s_bJ_,0,b_bL_[1],b_bL_[2],len_bK_);
      b_bL_[2]=new_position_bM_;
      return 0;}
    function index_of_int_bU_(i_bR_)
     {return 0<=i_bR_?i_bR_:_g_(_a4_(_am_,string_of_int_a5_(i_bR_)));}
    function add_int_index_bV_(i_bS_,idx_bT_)
     {return index_of_int_bU_(i_bS_+idx_bT_|0);}
    var _bW_=_a__(add_int_index_bV_,1);
    function _b3_(fmt_bX_){return _bs_(fmt_bX_,0,fmt_bX_.getLen());}
    function bad_conversion_b5_(sfmt_bY_,i_bZ_,c_b1_)
     {var
       _b0_=_a4_(_ap_,_a4_(sfmt_bY_,_aq_)),
       _b2_=_a4_(_ao_,_a4_(string_of_int_a5_(i_bZ_),_b0_));
      return _aT_(_a4_(_an_,_a4_(_br_(1,c_b1_),_b2_)));}
    function bad_conversion_format_cY_(fmt_b4_,i_b7_,c_b6_)
     {return bad_conversion_b5_(_b3_(fmt_b4_),i_b7_,c_b6_);}
    function incomplete_format_cZ_(fmt_b8_)
     {return _aT_(_a4_(_ar_,_a4_(_b3_(fmt_b8_),_as_)));}
    function extract_format_cu_(fmt_b9_,start_cf_,stop_ch_,widths_cj_)
     {function skip_positional_spec_ce_(start_b__)
       {if
         ((fmt_b9_.safeGet(start_b__)-48|0)<
          0||
          9<
          (fmt_b9_.safeGet(start_b__)-48|0))
         return start_b__;
        var i_b$_=start_b__+1|0;
        for(;;)
         {var _ca_=fmt_b9_.safeGet(i_b$_);
          if(48<=_ca_)
           {if(!(58<=_ca_)){var _cc_=i_b$_+1|0,i_b$_=_cc_;continue;}
            var _cb_=0;}
          else
           if(36===_ca_){var _cd_=i_b$_+1|0,_cb_=1;}else var _cb_=0;
          if(!_cb_)var _cd_=start_b__;
          return _cd_;}}
      var
       start_cg_=skip_positional_spec_ce_(start_cf_+1|0),
       b_ci_=_bN_((stop_ch_-start_cg_|0)+10|0);
      _bP_(b_ci_,37);
      var l1_ck_=widths_cj_,l2_cl_=0;
      for(;;)
       {if(l1_ck_)
         {var
           l_cm_=l1_ck_[2],
           _cn_=[0,l1_ck_[1],l2_cl_],
           l1_ck_=l_cm_,
           l2_cl_=_cn_;
          continue;}
        var i_co_=start_cg_,widths_cp_=l2_cl_;
        for(;;)
         {if(i_co_<=stop_ch_)
           {var _cq_=fmt_b9_.safeGet(i_co_);
            if(42===_cq_)
             {if(widths_cp_)
               {var t_cr_=widths_cp_[2];
                _bQ_(b_ci_,string_of_int_a5_(widths_cp_[1]));
                var
                 i_cs_=skip_positional_spec_ce_(i_co_+1|0),
                 i_co_=i_cs_,
                 widths_cp_=t_cr_;
                continue;}
              throw [0,_d_,_at_];}
            _bP_(b_ci_,_cq_);
            var _ct_=i_co_+1|0,i_co_=_ct_;
            continue;}
          return _bO_(b_ci_);}}}
    function extract_format_int_em_
     (conv_cA_,fmt_cy_,start_cx_,stop_cw_,widths_cv_)
     {var sfmt_cz_=extract_format_cu_(fmt_cy_,start_cx_,stop_cw_,widths_cv_);
      if(78!==conv_cA_&&110!==conv_cA_)return sfmt_cz_;
      sfmt_cz_.safeSet(sfmt_cz_.getLen()-1|0,117);
      return sfmt_cz_;}
    function sub_format_c0_
     (incomplete_format_cH_,bad_conversion_format_cR_,conv_cW_,fmt_cB_,i_cV_)
     {var len_cC_=fmt_cB_.getLen();
      function sub_fmt_cT_(c_cD_,i_cQ_)
       {var close_cE_=40===c_cD_?41:125;
        function sub_cP_(j_cF_)
         {var j_cG_=j_cF_;
          for(;;)
           {if(len_cC_<=j_cG_)return _a__(incomplete_format_cH_,fmt_cB_);
            if(37===fmt_cB_.safeGet(j_cG_))
             {var _cI_=j_cG_+1|0;
              if(len_cC_<=_cI_)
               var _cJ_=_a__(incomplete_format_cH_,fmt_cB_);
              else
               {var _cK_=fmt_cB_.safeGet(_cI_),_cL_=_cK_-40|0;
                if(_cL_<0||1<_cL_)
                 {var _cM_=_cL_-83|0;
                  if(_cM_<0||2<_cM_)
                   var _cN_=1;
                  else
                   switch(_cM_)
                    {case 1:var _cN_=1;break;
                     case 2:var _cO_=1,_cN_=0;break;
                     default:var _cO_=0,_cN_=0;}
                  if(_cN_){var _cJ_=sub_cP_(_cI_+1|0),_cO_=2;}}
                else
                 var _cO_=0===_cL_?0:1;
                switch(_cO_)
                 {case 1:
                   var
                    _cJ_=
                     _cK_===close_cE_
                      ?_cI_+1|0
                      :_cS_(bad_conversion_format_cR_,fmt_cB_,i_cQ_,_cK_);
                   break;
                  case 2:break;
                  default:var _cJ_=sub_cP_(sub_fmt_cT_(_cK_,_cI_+1|0)+1|0);}}
              return _cJ_;}
            var _cU_=j_cG_+1|0,j_cG_=_cU_;
            continue;}}
        return sub_cP_(i_cQ_);}
      return sub_fmt_cT_(conv_cW_,i_cV_);}
    function sub_format_for_printf_do_(conv_cX_)
     {return _cS_
              (sub_format_c0_,
               incomplete_format_cZ_,
               bad_conversion_format_cY_,
               conv_cX_);}
    function iter_on_format_args_dE_(fmt_c1_,add_conv_da_,add_char_dk_)
     {var lim_c2_=fmt_c1_.getLen()-1|0;
      function scan_fmt_dm_(i_c3_)
       {var i_c4_=i_c3_;
        a:
        for(;;)
         {if(i_c4_<lim_c2_)
           {if(37===fmt_c1_.safeGet(i_c4_))
             {var skip_c5_=0,i_c6_=i_c4_+1|0;
              for(;;)
               {if(lim_c2_<i_c6_)
                 var _c7_=incomplete_format_cZ_(fmt_c1_);
                else
                 {var _c8_=fmt_c1_.safeGet(i_c6_);
                  if(58<=_c8_)
                   {if(95===_c8_)
                     {var _c__=i_c6_+1|0,_c9_=1,skip_c5_=_c9_,i_c6_=_c__;
                      continue;}}
                  else
                   if(32<=_c8_)
                    switch(_c8_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _c$_=i_c6_+1|0,i_c6_=_c$_;continue;
                      case 10:
                       var _db_=_cS_(add_conv_da_,skip_c5_,i_c6_,105),i_c6_=_db_;
                       continue;
                      default:var _dc_=i_c6_+1|0,i_c6_=_dc_;continue;}
                  var i_dd_=i_c6_;
                  c:
                  for(;;)
                   {if(lim_c2_<i_dd_)
                     var _de_=incomplete_format_cZ_(fmt_c1_);
                    else
                     {var _df_=fmt_c1_.safeGet(i_dd_);
                      if(126<=_df_)
                       var _dg_=0;
                      else
                       switch(_df_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,105),_dg_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,102),_dg_=1;break;
                         case 33:
                         case 37:
                         case 44:
                         case 64:var _de_=i_dd_+1|0,_dg_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,115),_dg_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,_df_),_dg_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_dh_=i_dd_+1|0;
                          if(lim_c2_<j_dh_)
                           {var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,105),_dg_=1;}
                          else
                           {var _di_=fmt_c1_.safeGet(j_dh_)-88|0;
                            if(_di_<0||32<_di_)
                             var _dj_=1;
                            else
                             switch(_di_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _de_=
                                  _dl_
                                   (add_char_dk_,_cS_(add_conv_da_,skip_c5_,i_dd_,_df_),105),
                                 _dg_=1,
                                 _dj_=0;
                                break;
                               default:var _dj_=1;}
                            if(_dj_)
                             {var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,105),_dg_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,99),_dg_=1;break;
                         case 66:
                         case 98:
                          var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,66),_dg_=1;break;
                         case 41:
                         case 125:
                          var _de_=_cS_(add_conv_da_,skip_c5_,i_dd_,_df_),_dg_=1;
                          break;
                         case 40:
                          var
                           _de_=scan_fmt_dm_(_cS_(add_conv_da_,skip_c5_,i_dd_,_df_)),
                           _dg_=1;
                          break;
                         case 123:
                          var
                           i_dn_=_cS_(add_conv_da_,skip_c5_,i_dd_,_df_),
                           j_dp_=_cS_(sub_format_for_printf_do_,_df_,fmt_c1_,i_dn_),
                           i_dq_=i_dn_;
                          for(;;)
                           {if(i_dq_<(j_dp_-2|0))
                             {var
                               _dr_=_dl_(add_char_dk_,i_dq_,fmt_c1_.safeGet(i_dq_)),
                               i_dq_=_dr_;
                              continue;}
                            var _ds_=j_dp_-1|0,i_dd_=_ds_;
                            continue c;}
                         default:var _dg_=0;}
                      if(!_dg_)
                       var _de_=bad_conversion_format_cY_(fmt_c1_,i_dd_,_df_);}
                    var _c7_=_de_;
                    break;}}
                var i_c4_=_c7_;
                continue a;}}
            var _dt_=i_c4_+1|0,i_c4_=_dt_;
            continue;}
          return i_c4_;}}
      scan_fmt_dm_(0);
      return 0;}
    function count_arguments_of_format_fB_(fmt_dF_)
     {var ac_du_=[0,0,0,0];
      function add_conv_dD_(skip_dz_,i_dA_,c_dv_)
       {var _dw_=41!==c_dv_?1:0,_dx_=_dw_?125!==c_dv_?1:0:_dw_;
        if(_dx_)
         {var inc_dy_=97===c_dv_?2:1;
          if(114===c_dv_)ac_du_[3]=ac_du_[3]+1|0;
          if(skip_dz_)
           ac_du_[2]=ac_du_[2]+inc_dy_|0;
          else
           ac_du_[1]=ac_du_[1]+inc_dy_|0;}
        return i_dA_+1|0;}
      iter_on_format_args_dE_
       (fmt_dF_,add_conv_dD_,function(i_dB_,param_dC_){return i_dB_+1|0;});
      return ac_du_[1];}
    function scan_positional_spec_ei_(fmt_dG_,got_spec_dJ_,i_dH_)
     {var _dI_=fmt_dG_.safeGet(i_dH_);
      if((_dI_-48|0)<0||9<(_dI_-48|0))return _dl_(got_spec_dJ_,0,i_dH_);
      var accu_dK_=_dI_-48|0,j_dL_=i_dH_+1|0;
      for(;;)
       {var _dM_=fmt_dG_.safeGet(j_dL_);
        if(48<=_dM_)
         {if(!(58<=_dM_))
           {var
             _dP_=j_dL_+1|0,
             _dO_=(10*accu_dK_|0)+(_dM_-48|0)|0,
             accu_dK_=_dO_,
             j_dL_=_dP_;
            continue;}
          var _dN_=0;}
        else
         if(36===_dM_)
          if(0===accu_dK_)
           {var _dQ_=_g_(_av_),_dN_=1;}
          else
           {var
             _dQ_=
              _dl_(got_spec_dJ_,[0,index_of_int_bU_(accu_dK_-1|0)],j_dL_+1|0),
             _dN_=1;}
         else
          var _dN_=0;
        if(!_dN_)var _dQ_=_dl_(got_spec_dJ_,0,i_dH_);
        return _dQ_;}}
    function next_index_ed_(spec_dR_,n_dS_)
     {return spec_dR_?n_dS_:_a__(_bW_,n_dS_);}
    function get_index_d4_(spec_dT_,n_dU_){return spec_dT_?spec_dT_[1]:n_dU_;}
    function _g9_
     (to_s_f2_,get_out_dW_,outc_gc_,outs_f3_,flush_fG_,k_gi_,fmt_dV_)
     {var out_dX_=_a__(get_out_dW_,fmt_dV_);
      function pr_fF_(k_d2_,n_gh_,fmt_dY_,v_d7_)
       {var len_d1_=fmt_dY_.getLen();
        function doprn_fC_(n_f$_,i_dZ_)
         {var i_d0_=i_dZ_;
          for(;;)
           {if(len_d1_<=i_d0_)return _a__(k_d2_,out_dX_);
            var _d3_=fmt_dY_.safeGet(i_d0_);
            if(37===_d3_)
             {var
               get_arg_d$_=
                function(spec_d6_,n_d5_)
                 {return caml_array_get(v_d7_,get_index_d4_(spec_d6_,n_d5_));},
               scan_flags_ef_=
                function(spec_eh_,n_ea_,widths_ec_,i_d8_)
                 {var i_d9_=i_d8_;
                  for(;;)
                   {var _d__=fmt_dY_.safeGet(i_d9_)-32|0;
                    if(!(_d__<0||25<_d__))
                     switch(_d__)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_ei_
                                (fmt_dY_,
                                 function(wspec_eb_,i_eg_)
                                  {var _ee_=[0,get_arg_d$_(wspec_eb_,n_ea_),widths_ec_];
                                   return scan_flags_ef_
                                           (spec_eh_,next_index_ed_(wspec_eb_,n_ea_),_ee_,i_eg_);},
                                 i_d9_+1|0);
                       default:var _ej_=i_d9_+1|0,i_d9_=_ej_;continue;}
                    var _ek_=fmt_dY_.safeGet(i_d9_);
                    if(124<=_ek_)
                     var _el_=0;
                    else
                     switch(_ek_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_en_=get_arg_d$_(spec_eh_,n_ea_),
                         s_eo_=
                          caml_format_int
                           (extract_format_int_em_(_ek_,fmt_dY_,i_d0_,i_d9_,widths_ec_),
                            x_en_),
                         _eq_=
                          cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),s_eo_,i_d9_+1|0),
                         _el_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_er_=get_arg_d$_(spec_eh_,n_ea_),
                         s_es_=
                          caml_format_float
                           (extract_format_cu_(fmt_dY_,i_d0_,i_d9_,widths_ec_),x_er_),
                         _eq_=
                          cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),s_es_,i_d9_+1|0),
                         _el_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _et_=fmt_dY_.safeGet(i_d9_+1|0)-88|0;
                        if(_et_<0||32<_et_)
                         var _eu_=1;
                        else
                         switch(_et_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_ev_=i_d9_+1|0,_ew_=_ek_-108|0;
                            if(_ew_<0||2<_ew_)
                             var _ex_=0;
                            else
                             {switch(_ew_)
                               {case 1:var _ex_=0,_ey_=0;break;
                                case 2:
                                 var
                                  x_ez_=get_arg_d$_(spec_eh_,n_ea_),
                                  _eA_=
                                   caml_format_int
                                    (extract_format_cu_(fmt_dY_,i_d0_,i_ev_,widths_ec_),x_ez_),
                                  _ey_=1;
                                 break;
                                default:
                                 var
                                  x_eB_=get_arg_d$_(spec_eh_,n_ea_),
                                  _eA_=
                                   caml_format_int
                                    (extract_format_cu_(fmt_dY_,i_d0_,i_ev_,widths_ec_),x_eB_),
                                  _ey_=1;}
                              if(_ey_){var s_eC_=_eA_,_ex_=1;}}
                            if(!_ex_)
                             {var
                               x_eD_=get_arg_d$_(spec_eh_,n_ea_),
                               s_eC_=
                                caml_int64_format
                                 (extract_format_cu_(fmt_dY_,i_d0_,i_ev_,widths_ec_),x_eD_);}
                            var
                             _eq_=
                              cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),s_eC_,i_ev_+1|0),
                             _el_=1,
                             _eu_=0;
                            break;
                           default:var _eu_=1;}
                        if(_eu_)
                         {var
                           x_eE_=get_arg_d$_(spec_eh_,n_ea_),
                           s_eF_=
                            caml_format_int
                             (extract_format_int_em_(110,fmt_dY_,i_d0_,i_d9_,widths_ec_),
                              x_eE_),
                           _eq_=
                            cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),s_eF_,i_d9_+1|0),
                           _el_=1;}
                        break;
                       case 37:
                       case 64:
                        var _eq_=cont_s_ep_(n_ea_,_br_(1,_ek_),i_d9_+1|0),_el_=1;
                        break;
                       case 83:
                       case 115:
                        var x_eG_=get_arg_d$_(spec_eh_,n_ea_);
                        if(115===_ek_)
                         var x_eH_=x_eG_;
                        else
                         {var n_eI_=[0,0],_eJ_=0,_eK_=x_eG_.getLen()-1|0;
                          if(!(_eK_<_eJ_))
                           {var i_eL_=_eJ_;
                            for(;;)
                             {var
                               _eM_=x_eG_.safeGet(i_eL_),
                               _eN_=
                                14<=_eM_
                                 ?34===_eM_?1:92===_eM_?1:0
                                 :11<=_eM_?13<=_eM_?1:0:8<=_eM_?1:0,
                               _eO_=_eN_?2:caml_is_printable(_eM_)?1:4;
                              n_eI_[1]=n_eI_[1]+_eO_|0;
                              var _eP_=i_eL_+1|0;
                              if(_eK_!==i_eL_){var i_eL_=_eP_;continue;}
                              break;}}
                          if(n_eI_[1]===x_eG_.getLen())
                           var _eQ_=x_eG_;
                          else
                           {var s__eR_=caml_create_string(n_eI_[1]);
                            n_eI_[1]=0;
                            var _eS_=0,_eT_=x_eG_.getLen()-1|0;
                            if(!(_eT_<_eS_))
                             {var i_eU_=_eS_;
                              for(;;)
                               {var _eV_=x_eG_.safeGet(i_eU_),_eW_=_eV_-34|0;
                                if(_eW_<0||58<_eW_)
                                 if(-20<=_eW_)
                                  var _eX_=1;
                                 else
                                  {switch(_eW_+34|0)
                                    {case 8:
                                      s__eR_.safeSet(n_eI_[1],92);
                                      n_eI_[1]+=1;
                                      s__eR_.safeSet(n_eI_[1],98);
                                      var _eY_=1;
                                      break;
                                     case 9:
                                      s__eR_.safeSet(n_eI_[1],92);
                                      n_eI_[1]+=1;
                                      s__eR_.safeSet(n_eI_[1],116);
                                      var _eY_=1;
                                      break;
                                     case 10:
                                      s__eR_.safeSet(n_eI_[1],92);
                                      n_eI_[1]+=1;
                                      s__eR_.safeSet(n_eI_[1],110);
                                      var _eY_=1;
                                      break;
                                     case 13:
                                      s__eR_.safeSet(n_eI_[1],92);
                                      n_eI_[1]+=1;
                                      s__eR_.safeSet(n_eI_[1],114);
                                      var _eY_=1;
                                      break;
                                     default:var _eX_=1,_eY_=0;}
                                   if(_eY_)var _eX_=0;}
                                else
                                 var
                                  _eX_=
                                   (_eW_-1|0)<0||56<(_eW_-1|0)
                                    ?(s__eR_.safeSet(n_eI_[1],92),
                                      n_eI_[1]+=
                                      1,
                                      s__eR_.safeSet(n_eI_[1],_eV_),
                                      0)
                                    :1;
                                if(_eX_)
                                 if(caml_is_printable(_eV_))
                                  s__eR_.safeSet(n_eI_[1],_eV_);
                                 else
                                  {s__eR_.safeSet(n_eI_[1],92);
                                   n_eI_[1]+=1;
                                   s__eR_.safeSet(n_eI_[1],48+(_eV_/100|0)|0);
                                   n_eI_[1]+=1;
                                   s__eR_.safeSet(n_eI_[1],48+((_eV_/10|0)%10|0)|0);
                                   n_eI_[1]+=1;
                                   s__eR_.safeSet(n_eI_[1],48+(_eV_%10|0)|0);}
                                n_eI_[1]+=1;
                                var _eZ_=i_eU_+1|0;
                                if(_eT_!==i_eU_){var i_eU_=_eZ_;continue;}
                                break;}}
                            var _eQ_=s__eR_;}
                          var x_eH_=_a4_(_az_,_a4_(_eQ_,_aA_));}
                        if(i_d9_===(i_d0_+1|0))
                         var s_e0_=x_eH_;
                        else
                         {var
                           _e1_=
                            extract_format_cu_(fmt_dY_,i_d0_,i_d9_,widths_ec_);
                          try
                           {var neg_e2_=0,i_e3_=1;
                            for(;;)
                             {if(_e1_.getLen()<=i_e3_)
                               var _e4_=[0,0,neg_e2_];
                              else
                               {var _e5_=_e1_.safeGet(i_e3_);
                                if(49<=_e5_)
                                 if(58<=_e5_)
                                  var _e6_=0;
                                 else
                                  {var
                                    _e4_=
                                     [0,
                                      caml_int_of_string
                                       (_bs_(_e1_,i_e3_,(_e1_.getLen()-i_e3_|0)-1|0)),
                                      neg_e2_],
                                    _e6_=1;}
                                else
                                 {if(45===_e5_)
                                   {var _e8_=i_e3_+1|0,_e7_=1,neg_e2_=_e7_,i_e3_=_e8_;
                                    continue;}
                                  var _e6_=0;}
                                if(!_e6_){var _e9_=i_e3_+1|0,i_e3_=_e9_;continue;}}
                              var match_e__=_e4_;
                              break;}}
                          catch(_e$_)
                           {if(_e$_[1]!==_a_)throw _e$_;
                            var match_e__=bad_conversion_b5_(_e1_,0,115);}
                          var
                           p_fa_=match_e__[1],
                           _fb_=x_eH_.getLen(),
                           _fc_=0,
                           neg_fg_=match_e__[2],
                           _ff_=32;
                          if(p_fa_===_fb_&&0===_fc_)
                           {var _fd_=x_eH_,_fe_=1;}
                          else
                           var _fe_=0;
                          if(!_fe_)
                           if(p_fa_<=_fb_)
                            var _fd_=_bs_(x_eH_,_fc_,_fb_);
                           else
                            {var res_fh_=_br_(p_fa_,_ff_);
                             if(neg_fg_)
                              _bt_(x_eH_,_fc_,res_fh_,0,_fb_);
                             else
                              _bt_(x_eH_,_fc_,res_fh_,p_fa_-_fb_|0,_fb_);
                             var _fd_=res_fh_;}
                          var s_e0_=_fd_;}
                        var
                         _eq_=
                          cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),s_e0_,i_d9_+1|0),
                         _el_=1;
                        break;
                       case 67:
                       case 99:
                        var x_fi_=get_arg_d$_(spec_eh_,n_ea_);
                        if(99===_ek_)
                         var s_fj_=_br_(1,x_fi_);
                        else
                         {if(39===x_fi_)
                           var _fk_=_aH_;
                          else
                           if(92===x_fi_)
                            var _fk_=_aI_;
                           else
                            {if(14<=x_fi_)
                              var _fl_=0;
                             else
                              switch(x_fi_)
                               {case 8:var _fk_=_aM_,_fl_=1;break;
                                case 9:var _fk_=_aL_,_fl_=1;break;
                                case 10:var _fk_=_aK_,_fl_=1;break;
                                case 13:var _fk_=_aJ_,_fl_=1;break;
                                default:var _fl_=0;}
                             if(!_fl_)
                              if(caml_is_printable(x_fi_))
                               {var s_fm_=caml_create_string(1);
                                s_fm_.safeSet(0,x_fi_);
                                var _fk_=s_fm_;}
                              else
                               {var s_fn_=caml_create_string(4);
                                s_fn_.safeSet(0,92);
                                s_fn_.safeSet(1,48+(x_fi_/100|0)|0);
                                s_fn_.safeSet(2,48+((x_fi_/10|0)%10|0)|0);
                                s_fn_.safeSet(3,48+(x_fi_%10|0)|0);
                                var _fk_=s_fn_;}}
                          var s_fj_=_a4_(_ax_,_a4_(_fk_,_ay_));}
                        var
                         _eq_=
                          cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),s_fj_,i_d9_+1|0),
                         _el_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _fp_=i_d9_+1|0,
                         _fo_=get_arg_d$_(spec_eh_,n_ea_)?_aP_:_aO_,
                         _eq_=cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),_fo_,_fp_),
                         _el_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_fq_=get_arg_d$_(spec_eh_,n_ea_),
                         j_fr_=_cS_(sub_format_for_printf_do_,_ek_,fmt_dY_,i_d9_+1|0);
                        if(123===_ek_)
                         {var
                           b_fs_=_bN_(xf_fq_.getLen()),
                           add_char_fw_=
                            function(i_fu_,c_ft_){_bP_(b_fs_,c_ft_);return i_fu_+1|0;};
                          iter_on_format_args_dE_
                           (xf_fq_,
                            function(skip_fv_,i_fy_,c_fx_)
                             {if(skip_fv_)_bQ_(b_fs_,_au_);else _bP_(b_fs_,37);
                              return add_char_fw_(i_fy_,c_fx_);},
                            add_char_fw_);
                          var
                           _fz_=_bO_(b_fs_),
                           _eq_=cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),_fz_,j_fr_),
                           _el_=1;}
                        else
                         {var
                           _fA_=next_index_ed_(spec_eh_,n_ea_),
                           m_fD_=
                            add_int_index_bV_
                             (count_arguments_of_format_fB_(xf_fq_),_fA_),
                           _eq_=
                            pr_fF_
                             (function(param_fE_){return doprn_fC_(m_fD_,j_fr_);},
                              _fA_,
                              xf_fq_,
                              v_d7_),
                           _el_=1;}
                        break;
                       case 33:
                        _a__(flush_fG_,out_dX_);
                        var _eq_=doprn_fC_(n_ea_,i_d9_+1|0),_el_=1;
                        break;
                       case 41:
                        var _eq_=cont_s_ep_(n_ea_,_aC_,i_d9_+1|0),_el_=1;break;
                       case 44:
                        var _eq_=cont_s_ep_(n_ea_,_aB_,i_d9_+1|0),_el_=1;break;
                       case 70:
                        var x_fH_=get_arg_d$_(spec_eh_,n_ea_);
                        if(0===widths_ec_)
                         {var
                           _fI_=caml_format_float(_aS_,x_fH_),
                           i_fJ_=0,
                           l_fK_=_fI_.getLen();
                          for(;;)
                           {if(l_fK_<=i_fJ_)
                             var _fL_=_a4_(_fI_,_aR_);
                            else
                             {var
                               _fM_=_fI_.safeGet(i_fJ_),
                               _fN_=48<=_fM_?58<=_fM_?0:1:45===_fM_?1:0;
                              if(_fN_){var _fO_=i_fJ_+1|0,i_fJ_=_fO_;continue;}
                              var _fL_=_fI_;}
                            var s_fP_=_fL_;
                            break;}}
                        else
                         {var
                           sfmt_fQ_=
                            extract_format_cu_(fmt_dY_,i_d0_,i_d9_,widths_ec_);
                          if(70===_ek_)sfmt_fQ_.safeSet(sfmt_fQ_.getLen()-1|0,103);
                          var s_fR_=caml_format_float(sfmt_fQ_,x_fH_);
                          if(3<=caml_classify_float(x_fH_))
                           var _fS_=s_fR_;
                          else
                           {var i_fT_=0,l_fU_=s_fR_.getLen();
                            for(;;)
                             {if(l_fU_<=i_fT_)
                               var _fV_=_a4_(s_fR_,_aw_);
                              else
                               {var
                                 _fW_=s_fR_.safeGet(i_fT_)-46|0,
                                 _fX_=
                                  _fW_<0||23<_fW_
                                   ?55===_fW_?1:0
                                   :(_fW_-1|0)<0||21<(_fW_-1|0)?1:0;
                                if(!_fX_){var _fY_=i_fT_+1|0,i_fT_=_fY_;continue;}
                                var _fV_=s_fR_;}
                              var _fS_=_fV_;
                              break;}}
                          var s_fP_=_fS_;}
                        var
                         _eq_=
                          cont_s_ep_(next_index_ed_(spec_eh_,n_ea_),s_fP_,i_d9_+1|0),
                         _el_=1;
                        break;
                       case 91:
                        var
                         _eq_=bad_conversion_format_cY_(fmt_dY_,i_d9_,_ek_),
                         _el_=1;
                        break;
                       case 97:
                        var
                         printer_fZ_=get_arg_d$_(spec_eh_,n_ea_),
                         n_f0_=_a__(_bW_,get_index_d4_(spec_eh_,n_ea_)),
                         arg_f1_=get_arg_d$_(0,n_f0_),
                         _f5_=i_d9_+1|0,
                         _f4_=next_index_ed_(spec_eh_,n_f0_);
                        if(to_s_f2_)
                         _dl_(outs_f3_,out_dX_,_dl_(printer_fZ_,0,arg_f1_));
                        else
                         _dl_(printer_fZ_,out_dX_,arg_f1_);
                        var _eq_=doprn_fC_(_f4_,_f5_),_el_=1;
                        break;
                       case 114:
                        var
                         _eq_=bad_conversion_format_cY_(fmt_dY_,i_d9_,_ek_),
                         _el_=1;
                        break;
                       case 116:
                        var
                         printer_f6_=get_arg_d$_(spec_eh_,n_ea_),
                         _f8_=i_d9_+1|0,
                         _f7_=next_index_ed_(spec_eh_,n_ea_);
                        if(to_s_f2_)
                         _dl_(outs_f3_,out_dX_,_a__(printer_f6_,0));
                        else
                         _a__(printer_f6_,out_dX_);
                        var _eq_=doprn_fC_(_f7_,_f8_),_el_=1;
                        break;
                       default:var _el_=0;}
                    if(!_el_)
                     var _eq_=bad_conversion_format_cY_(fmt_dY_,i_d9_,_ek_);
                    return _eq_;}},
               _gb_=i_d0_+1|0,
               _f__=0;
              return scan_positional_spec_ei_
                      (fmt_dY_,
                       function(spec_ga_,i_f9_)
                        {return scan_flags_ef_(spec_ga_,n_f$_,_f__,i_f9_);},
                       _gb_);}
            _dl_(outc_gc_,out_dX_,_d3_);
            var _gd_=i_d0_+1|0,i_d0_=_gd_;
            continue;}}
        function cont_s_ep_(n_gg_,s_ge_,i_gf_)
         {_dl_(outs_f3_,out_dX_,s_ge_);return doprn_fC_(n_gg_,i_gf_);}
        return doprn_fC_(n_gh_,0);}
      var
       kpr_gj_=_dl_(pr_fF_,k_gi_,index_of_int_bU_(0)),
       _gk_=count_arguments_of_format_fB_(fmt_dV_);
      if(_gk_<0||6<_gk_)
       {var
         loop_gx_=
          function(i_gl_,args_gr_)
           {if(_gk_<=i_gl_)
             {var
               a_gm_=caml_make_vect(_gk_,0),
               _gp_=
                function(i_gn_,arg_go_)
                 {return caml_array_set(a_gm_,(_gk_-i_gn_|0)-1|0,arg_go_);},
               i_gq_=0,
               param_gs_=args_gr_;
              for(;;)
               {if(param_gs_)
                 {var _gt_=param_gs_[2],_gu_=param_gs_[1];
                  if(_gt_)
                   {_gp_(i_gq_,_gu_);
                    var _gv_=i_gq_+1|0,i_gq_=_gv_,param_gs_=_gt_;
                    continue;}
                  _gp_(i_gq_,_gu_);}
                return _dl_(kpr_gj_,fmt_dV_,a_gm_);}}
            return function(x_gw_)
             {return loop_gx_(i_gl_+1|0,[0,x_gw_,args_gr_]);};},
         _gy_=loop_gx_(0,0);}
      else
       switch(_gk_)
        {case 1:
          var
           _gy_=
            function(x_gA_)
             {var a_gz_=caml_make_vect(1,0);
              caml_array_set(a_gz_,0,x_gA_);
              return _dl_(kpr_gj_,fmt_dV_,a_gz_);};
          break;
         case 2:
          var
           _gy_=
            function(x_gC_,y_gD_)
             {var a_gB_=caml_make_vect(2,0);
              caml_array_set(a_gB_,0,x_gC_);
              caml_array_set(a_gB_,1,y_gD_);
              return _dl_(kpr_gj_,fmt_dV_,a_gB_);};
          break;
         case 3:
          var
           _gy_=
            function(x_gF_,y_gG_,z_gH_)
             {var a_gE_=caml_make_vect(3,0);
              caml_array_set(a_gE_,0,x_gF_);
              caml_array_set(a_gE_,1,y_gG_);
              caml_array_set(a_gE_,2,z_gH_);
              return _dl_(kpr_gj_,fmt_dV_,a_gE_);};
          break;
         case 4:
          var
           _gy_=
            function(x_gJ_,y_gK_,z_gL_,t_gM_)
             {var a_gI_=caml_make_vect(4,0);
              caml_array_set(a_gI_,0,x_gJ_);
              caml_array_set(a_gI_,1,y_gK_);
              caml_array_set(a_gI_,2,z_gL_);
              caml_array_set(a_gI_,3,t_gM_);
              return _dl_(kpr_gj_,fmt_dV_,a_gI_);};
          break;
         case 5:
          var
           _gy_=
            function(x_gO_,y_gP_,z_gQ_,t_gR_,u_gS_)
             {var a_gN_=caml_make_vect(5,0);
              caml_array_set(a_gN_,0,x_gO_);
              caml_array_set(a_gN_,1,y_gP_);
              caml_array_set(a_gN_,2,z_gQ_);
              caml_array_set(a_gN_,3,t_gR_);
              caml_array_set(a_gN_,4,u_gS_);
              return _dl_(kpr_gj_,fmt_dV_,a_gN_);};
          break;
         case 6:
          var
           _gy_=
            function(x_gU_,y_gV_,z_gW_,t_gX_,u_gY_,v_gZ_)
             {var a_gT_=caml_make_vect(6,0);
              caml_array_set(a_gT_,0,x_gU_);
              caml_array_set(a_gT_,1,y_gV_);
              caml_array_set(a_gT_,2,z_gW_);
              caml_array_set(a_gT_,3,t_gX_);
              caml_array_set(a_gT_,4,u_gY_);
              caml_array_set(a_gT_,5,v_gZ_);
              return _dl_(kpr_gj_,fmt_dV_,a_gT_);};
          break;
         default:var _gy_=_dl_(kpr_gj_,fmt_dV_,[0]);}
      return _gy_;}
    function _g8_(fmt_g0_){return _bN_(2*fmt_g0_.getLen()|0);}
    function _g5_(k_g3_,b_g1_)
     {var s_g2_=_bO_(b_g1_);b_g1_[2]=0;return _a__(k_g3_,s_g2_);}
    function _hb_(k_g4_)
     {var _g7_=_a__(_g5_,k_g4_);
      return _g__(_g9_,1,_g8_,_bP_,_bQ_,function(_g6_){return 0;},_g7_);}
    var _hc_=[0,0];
    function _hd_(fmt_ha_)
     {return _dl_(_hb_,function(s_g$_){return s_g$_;},fmt_ha_);}
    32===_bu_;
    try
     {var _he_=caml_sys_getenv(_ak_),params_hf_=_he_;}
    catch(_hg_)
     {if(_hg_[1]!==_c_)throw _hg_;
      try
       {var _hh_=caml_sys_getenv(_aj_),_hi_=_hh_;}
      catch(_hj_){if(_hj_[1]!==_c_)throw _hj_;var _hi_=_ai_;}
      var params_hf_=_hi_;}
    var _hk_=0,l_hl_=params_hf_.getLen(),_ho_=82;
    if(0<=_hk_&&!(l_hl_<_hk_))
     try
      {var i_hn_=_hk_;
       for(;;)
        {if(l_hl_<=i_hn_)throw [0,_c_];
         if(params_hf_.safeGet(i_hn_)!==_ho_)
          {var _hp_=i_hn_+1|0,i_hn_=_hp_;continue;}
         var _hm_=1;
         break;}}
     catch(_hq_){if(_hq_[1]!==_c_)throw _hq_;var _hm_=1;}
    else
     var _hm_=0;
    if(!_hm_)_aT_(_aG_);
    function _ht_(param_hs_)
     {var seq_hr_=[];
      caml_update_dummy(seq_hr_,[0,seq_hr_,seq_hr_]);
      return seq_hr_;}
    var Canceled_hu_=[0,_aa_],current_data_hv_=[0,0],max_removed_iG_=42;
    function repr_rec_hz_(t_hw_)
     {var _hx_=t_hw_[1];
      {if(3===_hx_[0])
        {var t__hy_=_hx_[1],t___hA_=repr_rec_hz_(t__hy_);
         if(t___hA_!==t__hy_)t_hw_[1]=[3,t___hA_];
         return t___hA_;}
       return t_hw_;}}
    function repr_ik_(t_hB_){return repr_rec_hz_(t_hB_);}
    function run_waiters_h0_(waiters_hC_,state_hG_)
     {var ws_hD_=waiters_hC_,rem_hE_=0,save_hT_=current_data_hv_[1];
      for(;;)
       {if(typeof ws_hD_==="number")
         {if(rem_hE_)
           {var
             rem_hS_=rem_hE_[2],
             ws_hR_=rem_hE_[1],
             ws_hD_=ws_hR_,
             rem_hE_=rem_hS_;
            continue;}}
        else
         switch(ws_hD_[0])
          {case 1:
            var _hF_=ws_hD_[1];
            if(rem_hE_)
             {var rem_hI_=rem_hE_[2],ws_hH_=rem_hE_[1];
              _a__(_hF_,state_hG_);
              var ws_hD_=ws_hH_,rem_hE_=rem_hI_;
              continue;}
            _a__(_hF_,state_hG_);
            break;
           case 2:
            var
             ws1_hJ_=ws_hD_[1],
             _hK_=[0,ws_hD_[2],rem_hE_],
             ws_hD_=ws1_hJ_,
             rem_hE_=_hK_;
            continue;
           default:
            var _hL_=ws_hD_[1][1];
            if(_hL_)
             {var _hM_=_hL_[1];
              if(rem_hE_)
               {var rem_hO_=rem_hE_[2],ws_hN_=rem_hE_[1];
                _a__(_hM_,state_hG_);
                var ws_hD_=ws_hN_,rem_hE_=rem_hO_;
                continue;}
              _a__(_hM_,state_hG_);}
            else
             if(rem_hE_)
              {var
                rem_hQ_=rem_hE_[2],
                ws_hP_=rem_hE_[1],
                ws_hD_=ws_hP_,
                rem_hE_=rem_hQ_;
               continue;}}
        current_data_hv_[1]=save_hT_;
        return 0;}}
    function wakeup_iN_(t_hU_,v_hX_)
     {var t_hV_=repr_rec_hz_(t_hU_),_hW_=t_hV_[1];
      switch(_hW_[0])
       {case 1:if(_hW_[1][1]===Canceled_hu_)return 0;break;
        case 2:
         var state_hY_=[0,v_hX_],waiters_hZ_=_hW_[1][2];
         t_hV_[1]=state_hY_;
         return run_waiters_h0_(waiters_hZ_,state_hY_);
        default:}
      return _aT_(_ab_);}
    function append_h7_(l1_h1_,l2_h2_)
     {return typeof l1_h1_==="number"
              ?l2_h2_
              :typeof l2_h2_==="number"?l1_h1_:[2,l1_h1_,l2_h2_];}
    function cleanup_h4_(ws_h3_)
     {if(typeof ws_h3_!=="number")
       switch(ws_h3_[0])
        {case 2:
          var l1_h5_=ws_h3_[1],_h6_=cleanup_h4_(ws_h3_[2]);
          return append_h7_(cleanup_h4_(l1_h5_),_h6_);
         case 1:break;
         default:if(!ws_h3_[1][1])return 0;}
      return ws_h3_;}
    function fail_in_(e_h8_){return [0,[1,e_h8_]];}
    function task_iO_(param_ig_)
     {var t_h9_=[],_if_=0,_ie_=0;
      caml_update_dummy
       (t_h9_,
        [0,
         [2,
          [0,
           [0,
            [0,
             function(param_id_)
              {var t_h__=repr_rec_hz_(t_h9_),_h$_=t_h__[1];
               if(2===_h$_[0])
                {var state_ia_=[1,[0,Canceled_hu_]],waiters_ib_=_h$_[1][2];
                 t_h__[1]=state_ia_;
                 var _ic_=run_waiters_h0_(waiters_ib_,state_ia_);}
               else
                var _ic_=0;
               return _ic_;}]],
           _ie_,
           _if_]]]);
      return [0,t_h9_,t_h9_];}
    function add_immutable_waiter_iM_(sleeper_ih_,waiter_ii_)
     {var
       _ij_=
        typeof sleeper_ih_[2]==="number"
         ?[1,waiter_ii_]
         :[2,[1,waiter_ii_],sleeper_ih_[2]];
      sleeper_ih_[2]=_ij_;
      return 0;}
    function bind_iP_(t_il_,f_it_)
     {var _im_=repr_ik_(t_il_)[1];
      switch(_im_[0])
       {case 1:return fail_in_(_im_[1]);
        case 2:
         var
          sleeper_io_=_im_[1],
          _ip_=[0,[2,[0,sleeper_io_[1],0,0]]],
          data_ir_=current_data_hv_[1];
         add_immutable_waiter_iM_
          (sleeper_io_,
           function(param_iq_)
            {switch(param_iq_[0])
              {case 0:
                var v_is_=param_iq_[1];
                current_data_hv_[1]=data_ir_;
                try
                 {var _iu_=_a__(f_it_,v_is_),_iv_=_iu_;}
                catch(_iw_){var _iv_=fail_in_(_iw_);}
                var
                 t1_ix_=repr_ik_(_ip_),
                 t2_iy_=repr_ik_(_iv_),
                 _iz_=t1_ix_[1];
                if(2===_iz_[0])
                 {var sleeper1_iA_=_iz_[1];
                  if(t1_ix_===t2_iy_)
                   var _iB_=0;
                  else
                   {var _iC_=t2_iy_[1];
                    if(2===_iC_[0])
                     {var sleeper2_iD_=_iC_[1];
                      t2_iy_[1]=[3,t1_ix_];
                      sleeper1_iA_[1][1]=[1,sleeper2_iD_[1]];
                      var
                       waiters_iE_=append_h7_(sleeper1_iA_[2],sleeper2_iD_[2]),
                       removed_iF_=sleeper1_iA_[3]+sleeper2_iD_[3]|0,
                       _iB_=
                        max_removed_iG_<removed_iF_
                         ?(sleeper1_iA_[3]=
                           0,
                           sleeper1_iA_[2]=
                           cleanup_h4_(waiters_iE_),
                           0)
                         :(sleeper1_iA_[3]=removed_iF_,sleeper1_iA_[2]=waiters_iE_,0);}
                    else
                     {t1_ix_[1]=_iC_;
                      var _iB_=run_waiters_h0_(sleeper1_iA_[2],_iC_);}}}
                else
                 var _iB_=_aT_(_ac_);
                return _iB_;
               case 1:
                var _iH_=[1,param_iq_[1]],t_iI_=repr_ik_(_ip_),_iJ_=t_iI_[1];
                if(2===_iJ_[0])
                 {var waiters_iK_=_iJ_[1][2];
                  t_iI_[1]=_iH_;
                  var _iL_=run_waiters_h0_(waiters_iK_,_iH_);}
                else
                 var _iL_=_aT_(_ad_);
                return _iL_;
               default:throw [0,_d_,_af_];}});
         return _ip_;
        case 3:throw [0,_d_,_ae_];
        default:return _a__(f_it_,_im_[1]);}}
    var
     _iQ_=[0],
     _iR_=[0,caml_make_vect(55,0),0],
     seed_iS_=0===_iQ_.length-1?[0,0]:_iQ_,
     l_iT_=seed_iS_.length-1,
     _iU_=0,
     _iV_=54;
    if(!(_iV_<_iU_))
     {var i_iW_=_iU_;
      for(;;)
       {caml_array_set(_iR_[1],i_iW_,i_iW_);
        var _iX_=i_iW_+1|0;
        if(_iV_!==i_iW_){var i_iW_=_iX_;continue;}
        break;}}
    var
     accu_iY_=[0,_al_],
     _iZ_=0,
     _i0_=55,
     _i1_=caml_greaterequal(_i0_,l_iT_)?_i0_:l_iT_,
     _i2_=54+_i1_|0;
    if(!(_i2_<_iZ_))
     {var i_i3_=_iZ_;
      for(;;)
       {var
         j_i4_=i_i3_%55|0,
         _i5_=accu_iY_[1],
         _i6_=
          _a4_
           (_i5_,
            string_of_int_a5_(caml_array_get(seed_iS_,caml_mod(i_i3_,l_iT_))));
        accu_iY_[1]=caml_md5_string(_i6_,0,_i6_.getLen());
        var _i7_=accu_iY_[1];
        caml_array_set
         (_iR_[1],
          j_i4_,
          (caml_array_get(_iR_[1],j_i4_)^
           (((_i7_.safeGet(0)+(_i7_.safeGet(1)<<8)|0)+(_i7_.safeGet(2)<<16)|0)+
            (_i7_.safeGet(3)<<24)|
            0))&
          1073741823);
        var _i8_=i_i3_+1|0;
        if(_i2_!==i_i3_){var i_i3_=_i8_;continue;}
        break;}}
    _iR_[2]=0;
    var
     pause_hook_i$_=[0,function(_i9_){return 0;}],
     _i__=_ht_(0),
     _jb_=[0,0],
     null_jf_=null,
     undefined_jg_=undefined,
     _true_jh_=true,
     _false_ji_=false,
     array_constructor_jj_=Array,
     date_constr_jk_=Date;
    function _jm_(param_je_)
     {if(_i__[2]===_i__)return 0;
      var tmp_ja_=_ht_(0);
      tmp_ja_[1][2]=_i__[2];
      _i__[2][1]=tmp_ja_[1];
      tmp_ja_[1]=_i__[1];
      _i__[1][2]=tmp_ja_;
      _i__[1]=_i__;
      _i__[2]=_i__;
      _jb_[1]=0;
      var curr_jc_=tmp_ja_[2];
      for(;;)
       {if(curr_jc_!==tmp_ja_)
         {if(curr_jc_[4])wakeup_iN_(curr_jc_[3],0);
          var _jd_=curr_jc_[2],curr_jc_=_jd_;
          continue;}
        return 0;}}
    function _jn_(e_jl_)
     {return e_jl_ instanceof array_constructor_jj_
              ?0
              :[0,new MlWrappedString(e_jl_.toString())];}
    _hc_[1]=[0,_jn_,_hc_[1]];
    function _jp_(_jo_){return _jo_;}
    function appendChild_jM_(p_jq_,n_jr_){p_jq_.appendChild(n_jr_);return 0;}
    function handler_jN_(f_jt_)
     {return _jp_
              (caml_js_wrap_callback
                (function(e_js_)
                  {if(e_js_)
                    {var res_ju_=_a__(f_jt_,e_js_);
                     if(!(res_ju_|0))e_js_.preventDefault();
                     return res_ju_;}
                   var _jv_=event,res_jw_=_a__(f_jt_,_jv_);
                   _jv_.returnValue=res_jw_;
                   return res_jw_;}));}
    function _jO_(s_jx_){return s_jx_.toString();}
    function _jP_(e_jy_,typ_jz_,h_jC_,capt_jJ_)
     {if(e_jy_.addEventListener===undefined_jg_)
       {var
         ev_jA_=_$_.toString().concat(typ_jz_),
         callback_jH_=
          function(e_jB_)
           {var _jG_=[0,h_jC_,e_jB_,[0]];
            return _a__
                    (function(_jF_,_jE_,_jD_)
                      {return caml_js_call(_jF_,_jE_,_jD_);},
                     _jG_);};
        e_jy_.attachEvent(ev_jA_,callback_jH_);
        return function(param_jI_)
         {return e_jy_.detachEvent(ev_jA_,callback_jH_);};}
      e_jy_.addEventListener(typ_jz_,h_jC_,capt_jJ_);
      return function(param_jK_)
       {return e_jy_.removeEventListener(typ_jz_,h_jC_,capt_jJ_);};}
    function _jQ_(id_jL_){return _a__(id_jL_,0);}
    var
     mouseup_jR_=_jO_(_K_),
     mousemove_jT_=_jO_(_J_),
     _2d__jS_=_I_.toString(),
     window_jU_=window,
     document_jV_=window_jU_.document,
     onIE_j7_=caml_js_on_ie(0)|0;
    function opt_iter_j__(x_jW_,f_jX_){return x_jW_?_a__(f_jX_,x_jW_[1]):0;}
    function createElement_j0_(doc_jZ_,name_jY_)
     {return doc_jZ_.createElement(name_jY_.toString());}
    function unsafeCreateElement_kh_(doc_j2_,name_j1_)
     {return createElement_j0_(doc_j2_,name_j1_);}
    function unsafeCreateElementEx_kd_(_type_j3_,name_j4_,doc_j6_,elt_j5_)
     {if(0===_type_j3_&&0===name_j4_)
       return createElement_j0_(doc_j6_,elt_j5_);
      if(onIE_j7_)
       {var a_j8_=new array_constructor_jj_();
        a_j8_.push(_N_.toString(),elt_j5_.toString());
        opt_iter_j__
         (_type_j3_,
          function(t_j9_)
           {a_j8_.push
             (_O_.toString(),caml_js_html_escape(t_j9_),_P_.toString());
            return 0;});
        opt_iter_j__
         (name_j4_,
          function(n_j$_)
           {a_j8_.push
             (_Q_.toString(),caml_js_html_escape(n_j$_),_R_.toString());
            return 0;});
        a_j8_.push(_M_.toString());
        return doc_j6_.createElement(a_j8_.join(_L_.toString()));}
      var res_ka_=createElement_j0_(doc_j6_,elt_j5_);
      opt_iter_j__(_type_j3_,function(t_kb_){return res_ka_.type=t_kb_;});
      opt_iter_j__(name_j4_,function(n_kc_){return res_ka_.name=n_kc_;});
      return res_ka_;}
    function createInput_kk_(_type_kg_,name_kf_,doc_ke_)
     {return unsafeCreateElementEx_kd_(_type_kg_,name_kf_,doc_ke_,_U_);}
    function createLabel_kl_(doc_ki_)
     {return unsafeCreateElement_kh_(doc_ki_,_V_);}
    function createDiv_km_(doc_kj_)
     {return unsafeCreateElement_kh_(doc_kj_,_W_);}
    var Canvas_not_available_kn_=[0,_H_];
    window.HTMLElement===undefined_jg_;
    pause_hook_i$_[1]=
    function(param_ko_)
     {return 1===param_ko_
              ?(window_jU_.setTimeout(caml_js_wrap_callback(_jm_),0),0)
              :0;};
    var
     width_kp_=600,
     pi_kq_=4*Math.atan(1),
     obliquity_kr_=23.5*pi_kq_/180,
     gamma_ks_=2,
     dark_kt_=Math.pow(0.2,gamma_ks_),
     button_type_ku_=_j_.toString();
    function toggle_button_lh_(txt1_kw_,txt2_ky_,action_kC_)
     {var
       state_kv_=[0,0],
       txt1_kx_=txt1_kw_.toString(),
       txt2_kA_=txt2_ky_.toString(),
       b_kz_=createInput_kk_([0,button_type_ku_],0,document_jV_);
      b_kz_.value=txt1_kx_;
      b_kz_.onclick=
      handler_jN_
       (function(param_kD_)
         {state_kv_[1]=1-state_kv_[1];
          var _kB_=state_kv_[1]?txt2_kA_:txt1_kx_;
          b_kz_.value=_kB_;
          _a__(action_kC_,state_kv_[1]);
          return _true_jh_;});
      return b_kz_;}
    function checkbox_li_(txt_kJ_,checked_kF_,action_kG_)
     {var b_kE_=createInput_kk_([0,_k_.toString()],0,document_jV_);
      b_kE_.checked=!!checked_kF_;
      b_kE_.onclick=
      handler_jN_
       (function(param_kH_)
         {_a__(action_kG_,b_kE_.checked|0);return _true_jh_;});
      var lab_kI_=createLabel_kl_(document_jV_);
      appendChild_jM_(lab_kI_,b_kE_);
      appendChild_jM_(lab_kI_,document_jV_.createTextNode(txt_kJ_.toString()));
      return lab_kI_;}
    function vertex_k$_(x_kM_,y_kL_,z_kK_){return [-1,x_kM_,y_kL_,z_kK_];}
    function vect_lj_(param_kO_,_kN_)
     {return [-1,
              _kN_[1]-param_kO_[1],
              _kN_[2]-param_kO_[2],
              _kN_[3]-param_kO_[3]];}
    function matrix_vect_mul_k5_(m_kT_,param_kP_)
     {var
       z_kQ_=param_kP_[3],
       y_kR_=param_kP_[2],
       x_kS_=param_kP_[1],
       r3_kU_=m_kT_[3],
       r2_kV_=m_kT_[2],
       r1_kW_=m_kT_[1];
      return [-1,
              x_kS_*r1_kW_[1]+y_kR_*r1_kW_[2]+z_kQ_*r1_kW_[3],
              x_kS_*r2_kV_[1]+y_kR_*r2_kV_[2]+z_kQ_*r2_kV_[3],
              x_kS_*r3_kU_[1]+y_kR_*r3_kU_[2]+z_kQ_*r3_kU_[3]];}
    function matrix_transp_k1_(m_kX_)
     {var r3_kY_=m_kX_[3],r2_kZ_=m_kX_[2],r1_k0_=m_kX_[1];
      return [0,
              [-1,r1_k0_[1],r2_kZ_[1],r3_kY_[1]],
              [-1,r1_k0_[2],r2_kZ_[2],r3_kY_[2]],
              [-1,r1_k0_[3],r2_kZ_[3],r3_kY_[3]]];}
    function matrix_mul_lk_(m_k4_,m__k2_)
     {var
       m__k3_=matrix_transp_k1_(m__k2_),
       _k6_=matrix_vect_mul_k5_(m__k3_,m_k4_[3]),
       _k7_=matrix_vect_mul_k5_(m__k3_,m_k4_[2]);
      return [0,matrix_vect_mul_k5_(m__k3_,m_k4_[1]),_k7_,_k6_];}
    function xz_rotation_ll_(phi_k8_)
     {var
       cos_phi_k9_=Math.cos(phi_k8_),
       sin_phi_k__=Math.sin(phi_k8_),
       _la_=vertex_k$_(-sin_phi_k__,0,cos_phi_k9_),
       _lb_=vertex_k$_(0,1,0);
      return [0,vertex_k$_(cos_phi_k9_,0,sin_phi_k__),_lb_,_la_];}
    function xy_rotation_lm_(phi_lc_)
     {var
       cos_phi_ld_=Math.cos(phi_lc_),
       sin_phi_le_=Math.sin(phi_lc_),
       _lf_=vertex_k$_(0,0,1),
       _lg_=vertex_k$_(-sin_phi_le_,cos_phi_ld_,0);
      return [0,vertex_k$_(cos_phi_ld_,sin_phi_le_,0),_lg_,_lf_];}
    var matrix_identity_ln_=xz_rotation_ll_(0);
    function face_ly_(v1_lq_,v2_lp_,v3_lo_){return [0,v1_lq_,v2_lp_,v3_lo_];}
    function create_canvas_lz_(w_ls_,h_lt_)
     {var c_lr_=unsafeCreateElement_kh_(document_jV_,___);
      if(1-(c_lr_.getContext==null_jf_?1:0))
       {c_lr_.width=w_ls_;c_lr_.height=h_lt_;return c_lr_;}
      throw [0,Canvas_not_available_kn_];}
    function min_lA_(u_lu_,v_lv_){return u_lu_<v_lv_?u_lu_:v_lv_;}
    function max_lB_(u_lw_,v_lx_){return u_lw_<v_lx_?v_lx_:u_lw_;}
    var
     _lC_=8,
     _lD_=12,
     t_delta_lE_=pi_kq_/_lC_,
     n_lF_=_lC_*_lD_|0,
     vertices_lG_=caml_make_vect(n_lF_+2|0,vertex_k$_(0,0,0)),
     faces_lH_=caml_make_vect(n_lF_*2|0,face_ly_(0,0,0)),
     south_lI_=n_lF_+1|0;
    caml_array_set(vertices_lG_,n_lF_,vertex_k$_(0,-1,0));
    caml_array_set(vertices_lG_,south_lI_,vertex_k$_(0,1,0));
    var
     _lJ_=0,
     _lK_=_lD_-1|0,
     p_delta_lP_=2*pi_kq_/_lD_,
     t_offset_lR_=(pi_kq_-t_delta_lE_)/2;
    if(!(_lK_<_lJ_))
     {var i_lL_=_lJ_;
      for(;;)
       {var _lM_=0,_lN_=_lC_-1|0;
        if(!(_lN_<_lM_))
         {var j_lO_=_lM_;
          for(;;)
           {var
             phi_lQ_=i_lL_*p_delta_lP_,
             theta_lS_=j_lO_*t_delta_lE_-t_offset_lR_,
             k_lT_=(i_lL_*_lC_|0)+j_lO_|0;
            caml_array_set
             (vertices_lG_,
              k_lT_,
              vertex_k$_
               (Math.cos(phi_lQ_)*Math.cos(theta_lS_),
                Math.sin(theta_lS_),
                Math.sin(phi_lQ_)*Math.cos(theta_lS_)));
            if(0===j_lO_)
             {caml_array_set
               (faces_lH_,
                2*k_lT_|0,
                face_ly_(n_lF_,k_lT_,caml_mod(k_lT_+_lC_|0,n_lF_)));
              caml_array_set
               (faces_lH_,
                (2*k_lT_|0)+1|0,
                face_ly_
                 (south_lI_,
                  caml_mod((k_lT_+(2*_lC_|0)|0)-1|0,n_lF_),
                  (k_lT_+_lC_|0)-1|0));}
            else
             {caml_array_set
               (faces_lH_,
                2*k_lT_|0,
                face_ly_(k_lT_,caml_mod(k_lT_+_lC_|0,n_lF_),k_lT_-1|0));
              caml_array_set
               (faces_lH_,
                (2*k_lT_|0)+1|0,
                face_ly_
                 (k_lT_-1|0,
                  caml_mod(k_lT_+_lC_|0,n_lF_),
                  caml_mod((k_lT_+_lC_|0)-1|0,n_lF_)));}
            var _lU_=j_lO_+1|0;
            if(_lN_!==j_lO_){var j_lO_=_lU_;continue;}
            break;}}
        var _lV_=i_lL_+1|0;
        if(_lK_!==i_lL_){var i_lL_=_lV_;continue;}
        break;}}
    var texture_py_=_h_.toString();
    window_jU_.onload=
    handler_jN_
     (function(param_pC_)
       {function _pp_(texture_lW_)
         {var
           w_lX_=texture_lW_.width,
           h_lY_=texture_lW_.height,
           canvas_lZ_=create_canvas_lz_(w_lX_,h_lY_),
           ctx_l0_=canvas_lZ_.getContext(_2d__jS_),
           _l1_=h_lY_/8|0,
           _l2_=w_lX_/8|0,
           img_l3_=ctx_l0_.getImageData(0,0,_l2_,_l1_),
           data_l4_=img_l3_.data,
           inv_gamma_mi_=1/gamma_ks_;
          function update_shadow_mm_(obliquity_l5_)
           {var
             _l6_=0,
             _l7_=_l1_-1|0,
             cos_obl_mc_=Math.cos(obliquity_l5_),
             sin_obl_mb_=-Math.sin(obliquity_l5_);
            if(!(_l7_<_l6_))
             {var j_l8_=_l6_;
              for(;;)
               {var _l9_=0,_l__=(_l2_/2|0)-1|0;
                if(!(_l__<_l9_))
                 {var i_l$_=_l9_;
                  for(;;)
                   {var
                     theta_ma_=(j_l8_/_l1_-0.5)*pi_kq_,
                     _md_=
                      Math.cos(i_l$_/_l2_*2*pi_kq_)*
                      Math.cos(theta_ma_)*
                      cos_obl_mc_+
                      Math.sin(theta_ma_)*
                      sin_obl_mb_,
                     k_mg_=4*(i_l$_+j_l8_*_l2_)|0,
                     k__mf_=4*(_l2_-i_l$_+j_l8_*_l2_-1)|0,
                     c_me_=0<_md_?dark_kt_:dark_kt_-_md_*(1-dark_kt_)*1.2,
                     c_mh_=c_me_<=1?c_me_:1,
                     c_mj_=255-(255.99*Math.pow(c_mh_,inv_gamma_mi_)|0)|0;
                    data_l4_[k_mg_+3|0]=c_mj_;
                    data_l4_[k__mf_+3|0]=c_mj_;
                    var _mk_=i_l$_+1|0;
                    if(_l__!==i_l$_){var i_l$_=_mk_;continue;}
                    break;}}
                var _ml_=j_l8_+1|0;
                if(_l7_!==j_l8_){var j_l8_=_ml_;continue;}
                break;}}
            ctx_l0_.putImageData(img_l3_,0,0);
            ctx_l0_.globalCompositeOperation=_l_.toString();
            ctx_l0_.save();
            ctx_l0_.scale(8*(_l2_+2|0)/_l2_,8*(_l1_+2|0)/_l1_);
            ctx_l0_.translate(-1,-1);
            ctx_l0_.drawImage(canvas_lZ_,0,0);
            return ctx_l0_.restore();}
          update_shadow_mm_(obliquity_kr_);
          var
           w_mn_=texture_lW_.width,
           canvas__mo_=create_canvas_lz_(w_mn_,texture_lW_.height),
           ctx__mp_=canvas__mo_.getContext(_2d__jS_),
           no_lighting_mq_=[0,0],
           canvas_mr_=create_canvas_lz_(width_kp_,width_kp_),
           canvas__ms_=create_canvas_lz_(width_kp_,width_kp_);
          appendChild_jM_(document_jV_.body,canvas_mr_);
          var
           ctx_mt_=canvas_mr_.getContext(_2d__jS_),
           ctx__mu_=canvas__ms_.getContext(_2d__jS_),
           r_mv_=width_kp_/2,
           tw_mw_=texture_lW_.width,
           th_mx_=texture_lW_.height,
           uv_mB_=
            _be_
             (function(v_my_)
               {var
                 u_mz_=
                  (tw_mw_-
                   Math.atan2(v_my_[3],v_my_[1])*
                   ((tw_mw_/2-0.99)/pi_kq_)|
                   0)%
                  tw_mw_,
                 v_mA_=th_mx_/2+Math.asin(v_my_[2])*((th_mx_-0.99)/pi_kq_)|0;
                if(0<=u_mz_)
                 {if(u_mz_<tw_mw_)
                   {if(0<=v_mA_)
                     {if(v_mA_<th_mx_)return [0,u_mz_,v_mA_];throw [0,_d_,_m_];}
                    throw [0,_d_,_n_];}
                  throw [0,_d_,_o_];}
                throw [0,_d_,_p_];},
              vertices_lG_),
           normals_nr_=
            _be_
             (function(param_mC_)
               {var
                 v1_mD_=caml_array_get(vertices_lG_,param_mC_[1]),
                 v2_mF_=caml_array_get(vertices_lG_,param_mC_[2]),
                 _mE_=
                  vect_lj_(v1_mD_,caml_array_get(vertices_lG_,param_mC_[3])),
                 _mG_=vect_lj_(v1_mD_,v2_mF_),
                 z2_mH_=_mE_[3],
                 y2_mI_=_mE_[2],
                 x2_mJ_=_mE_[1],
                 z1_mK_=_mG_[3],
                 y1_mL_=_mG_[2],
                 x1_mM_=_mG_[1];
                return [-1,
                        y1_mL_*z2_mH_-y2_mI_*z1_mK_,
                        z1_mK_*x2_mJ_-z2_mH_*x1_mM_,
                        x1_mM_*y2_mI_-x2_mJ_*y1_mL_];},
              faces_lH_),
           paused_ns_=[0,0],
           follow_nt_=[0,0],
           lighting_nu_=[0,1],
           clipped_nv_=[0,1],
           obl_nw_=[0,obliquity_kr_],
           face_info_nx_=
            _be_
             (function(f_mN_)
               {var
                 match_mO_=caml_array_get(uv_mB_,f_mN_[1]),
                 v1_mP_=match_mO_[2],
                 u1_mQ_=match_mO_[1],
                 match_mR_=caml_array_get(uv_mB_,f_mN_[2]),
                 v2_mS_=match_mR_[2],
                 u2_mT_=match_mR_[1],
                 match_mU_=caml_array_get(uv_mB_,f_mN_[3]),
                 v3_mV_=match_mU_[2],
                 u3_mW_=match_mU_[1],
                 mid_mX_=tw_mw_/2;
                if(u1_mQ_==0)
                 {if(mid_mX_<u2_mT_||mid_mX_<u3_mW_)
                   var _mY_=1;
                  else
                   {var _mZ_=0,_mY_=0;}
                  if(_mY_){var u1_m0_=tw_mw_-2,_mZ_=1;}}
                else
                 var _mZ_=0;
                if(!_mZ_)var u1_m0_=u1_mQ_;
                if(u2_mT_==0)
                 {if(mid_mX_<u1_m0_||mid_mX_<u3_mW_)
                   var _m1_=1;
                  else
                   {var _m2_=0,_m1_=0;}
                  if(_m1_){var u2_m3_=tw_mw_-2,_m2_=1;}}
                else
                 var _m2_=0;
                if(!_m2_)var u2_m3_=u2_mT_;
                if(u3_mW_==0)
                 {if(mid_mX_<u2_m3_||mid_mX_<u1_m0_)
                   var _m4_=1;
                  else
                   {var _m5_=0,_m4_=0;}
                  if(_m4_){var u3_m6_=tw_mw_-2,_m5_=1;}}
                else
                 var _m5_=0;
                if(!_m5_)var u3_m6_=u3_mW_;
                var mth_m7_=th_mx_-2;
                if(v1_mP_==0||mth_m7_<=v1_mP_)
                 var _m8_=0;
                else
                 {var u1_m9_=u1_m0_,_m8_=1;}
                if(!_m8_)var u1_m9_=(u2_m3_+u3_m6_)/2;
                if(v2_mS_==0||mth_m7_<=v2_mS_)
                 var _m__=0;
                else
                 {var u2_m$_=u2_m3_,_m__=1;}
                if(!_m__)var u2_m$_=(u1_m9_+u3_m6_)/2;
                if(v3_mV_==0||mth_m7_<=v3_mV_)
                 var _na_=0;
                else
                 {var u3_nb_=u3_m6_,_na_=1;}
                if(!_na_)var u3_nb_=(u2_m$_+u1_m9_)/2;
                var
                 u1_nc_=max_lB_(1,u1_m9_),
                 u2_nd_=max_lB_(1,u2_m$_),
                 u3_ne_=max_lB_(1,u3_nb_),
                 v1_nf_=max_lB_(1,v1_mP_),
                 v2_ng_=max_lB_(1,v2_mS_),
                 v3_nh_=max_lB_(1,v3_mV_),
                 du2_ni_=u2_nd_-u1_nc_,
                 du3_nj_=u3_ne_-u1_nc_,
                 dv2_nk_=v2_ng_-v1_nf_,
                 dv3_nl_=v3_nh_-v1_nf_,
                 su_nm_=dv2_nk_*du3_nj_-dv3_nl_*du2_ni_,
                 sv_nn_=du2_ni_*dv3_nl_-du3_nj_*dv2_nk_,
                 u_no_=max_lB_(0,min_lA_(u1_nc_,min_lA_(u2_nd_,u3_ne_))-4),
                 v_np_=max_lB_(0,min_lA_(v1_nf_,min_lA_(v2_ng_,v3_nh_))-4),
                 u__nq_=
                  min_lA_(tw_mw_,max_lB_(u1_nc_,max_lB_(u2_nd_,u3_ne_))+4);
                return [0,
                        u1_nc_,
                        v1_nf_,
                        du2_ni_/su_nm_,
                        dv2_nk_/sv_nn_,
                        du3_nj_/su_nm_,
                        dv3_nl_/sv_nn_,
                        u_no_,
                        v_np_,
                        u__nq_-u_no_,
                        min_lA_(th_mx_,max_lB_(v1_nf_,max_lB_(v2_ng_,v3_nh_))+4)-
                        v_np_];},
              faces_lH_),
           m_obliq_ny_=[0,xy_rotation_lm_(-obliquity_kr_)],
           m_nz_=[0,matrix_identity_ln_],
           phi_rot_nA_=[0,0],
           rateText_nB_=document_jV_.createTextNode(_D_.toString()),
           ctrl_nC_=createDiv_km_(document_jV_);
          ctrl_nC_.className=_C_.toString();
          var d_nD_=createDiv_km_(document_jV_);
          appendChild_jM_(d_nD_,document_jV_.createTextNode(_B_.toString()));
          appendChild_jM_(ctrl_nC_,d_nD_);
          var form_nE_=createDiv_km_(document_jV_);
          function br_nH_(param_nF_)
           {return unsafeCreateElement_kh_(document_jV_,_Y_);}
          appendChild_jM_
           (form_nE_,
            toggle_button_lh_
             (_z_,_A_,function(p_nG_){paused_ns_[1]=p_nG_;return 0;}));
          appendChild_jM_(form_nE_,br_nH_(0));
          appendChild_jM_
           (form_nE_,
            toggle_button_lh_
             (_x_,_y_,function(f_nI_){follow_nt_[1]=f_nI_;return 0;}));
          appendChild_jM_(form_nE_,br_nH_(0));
          var b_nJ_=createInput_kk_([0,button_type_ku_],0,document_jV_);
          b_nJ_.value=_w_.toString();
          b_nJ_.onclick=
          handler_jN_
           (function(param_nK_)
             {m_nz_[1]=matrix_identity_ln_;
              phi_rot_nA_[1]=0;
              m_obliq_ny_[1]=xy_rotation_lm_(-obl_nw_[1]);
              return _true_jh_;});
          appendChild_jM_(form_nE_,b_nJ_);
          appendChild_jM_(form_nE_,br_nH_(0));
          var lab_nL_=createLabel_kl_(document_jV_);
          appendChild_jM_(lab_nL_,document_jV_.createTextNode(_v_.toString()));
          var
           _nM_=unsafeCreateElementEx_kd_(0,0,document_jV_,_T_),
           param_nN_=_u_;
          for(;;)
           {if(param_nN_)
             {var
               l_nQ_=param_nN_[2],
               a_nP_=param_nN_[1],
               _nO_=unsafeCreateElement_kh_(document_jV_,_S_);
              appendChild_jM_
               (_nO_,document_jV_.createTextNode(a_nP_.toString()));
              _nM_.add(_nO_,null_jf_);
              var param_nN_=l_nQ_;
              continue;}
            _nM_.onchange=
            handler_jN_
             (function(param_nT_)
               {var
                 _nR_=_nM_.selectedIndex,
                 o_nS_=0===_nR_?obliquity_kr_:1===_nR_?0:-obliquity_kr_;
                update_shadow_mm_(o_nS_);
                obl_nw_[1]=o_nS_;
                return _true_jh_;});
            appendChild_jM_(lab_nL_,_nM_);
            appendChild_jM_(form_nE_,lab_nL_);
            appendChild_jM_(ctrl_nC_,form_nE_);
            var form_nU_=createDiv_km_(document_jV_);
            appendChild_jM_
             (form_nU_,
              checkbox_li_
               (_t_,1,function(l_nV_){lighting_nu_[1]=l_nV_;return 0;}));
            appendChild_jM_(form_nU_,br_nH_(0));
            appendChild_jM_
             (form_nU_,
              checkbox_li_
               (_s_,1,function(l_nW_){clipped_nv_[1]=l_nW_;return 0;}));
            appendChild_jM_(form_nU_,br_nH_(0));
            appendChild_jM_
             (form_nU_,document_jV_.createTextNode(_r_.toString()));
            appendChild_jM_(form_nU_,rateText_nB_);
            appendChild_jM_(ctrl_nC_,form_nU_);
            appendChild_jM_(document_jV_.body,ctrl_nC_);
            var _nX_=unsafeCreateElement_kh_(document_jV_,_X_);
            _nX_.innerHTML=_q_.toString();
            appendChild_jM_(document_jV_.body,_nX_);
            var mx_nY_=[0,0],my_nZ_=[0,0];
            canvas_mr_.onmousedown=
            handler_jN_
             (function(ev_n0_)
               {mx_nY_[1]=ev_n0_.clientX;
                my_nZ_[1]=ev_n0_.clientY;
                var
                 c2_ob_=[0,null_jf_],
                 c1_oc_=
                  _jP_
                   (document_jV_,
                    mousemove_jT_,
                    handler_jN_
                     (function(ev_n1_)
                       {var
                         x_n2_=ev_n1_.clientX,
                         y_n3_=ev_n1_.clientY,
                         dx_n4_=x_n2_-mx_nY_[1]|0,
                         dy_n5_=y_n3_-my_nZ_[1]|0;
                        if(0!==dy_n5_)
                         {var
                           _n6_=2*dy_n5_/width_kp_,
                           cos_phi_n7_=Math.cos(_n6_),
                           sin_phi_n8_=Math.sin(_n6_),
                           _n9_=m_nz_[1],
                           _n__=vertex_k$_(0,-sin_phi_n8_,cos_phi_n7_),
                           _n$_=vertex_k$_(0,cos_phi_n7_,sin_phi_n8_);
                          m_nz_[1]=
                          matrix_mul_lk_([0,vertex_k$_(1,0,0),_n$_,_n__],_n9_);}
                        if(0!==dx_n4_)
                         {var _oa_=m_nz_[1];
                          m_nz_[1]=
                          matrix_mul_lk_(xz_rotation_ll_(2*dx_n4_/width_kp_),_oa_);}
                        mx_nY_[1]=x_n2_;
                        my_nZ_[1]=y_n3_;
                        return _true_jh_;}),
                    _true_jh_);
                c2_ob_[1]=
                _jp_
                 (_jP_
                   (document_jV_,
                    mouseup_jR_,
                    handler_jN_
                     (function(param_oe_)
                       {_jQ_(c1_oc_);
                        var _od_=c2_ob_[1];
                        if(_od_!=null_jf_)_jQ_(_od_);
                        return _true_jh_;}),
                    _true_jh_));
                return _false_ji_;});
            var
             ti_of_=[0,new date_constr_jk_().getTime()],
             fps_og_=[0,0],
             loop_o7_=
              function(t_o1_,phi_oh_)
               {var rotation_oi_=xz_rotation_ll_(phi_oh_-phi_rot_nA_[1]);
                if(lighting_nu_[1])
                 {no_lighting_mq_[1]=0;
                  ctx__mp_.drawImage(texture_lW_,0,0);
                  var
                   i_oj_=
                    (2*pi_kq_-phi_oh_%(2*pi_kq_))*w_mn_/2/pi_kq_%w_mn_|0;
                  ctx__mp_.drawImage(canvas_lZ_,i_oj_,0);
                  ctx__mp_.drawImage(canvas_lZ_,i_oj_-w_mn_,0);}
                else
                 if(!no_lighting_mq_[1])
                  {ctx__mp_.drawImage(texture_lW_,0,0);no_lighting_mq_[1]=1;}
                var
                 _ok_=matrix_mul_lk_(m_obliq_ny_[1],rotation_oi_),
                 m_ol_=matrix_mul_lk_(m_nz_[1],_ok_),
                 _on_=
                  _be_
                   (function(v_om_){return matrix_vect_mul_k5_(m_ol_,v_om_);},
                    vertices_lG_),
                 _oo_=matrix_vect_mul_k5_(matrix_transp_k1_(m_ol_),v_i_);
                ctx__mu_.clearRect(0,0,width_kp_,width_kp_);
                ctx__mu_.save();
                if(clipped_nv_[1])
                 {ctx__mu_.beginPath();
                  ctx__mu_.arc(r_mv_,r_mv_,r_mv_*0.95,0,-2*pi_kq_,_true_jh_);
                  ctx__mu_.clip();}
                ctx__mu_.setTransform(r_mv_-2,0,0,r_mv_-2,r_mv_,r_mv_);
                ctx__mu_.globalCompositeOperation=_G_.toString();
                var _op_=0,_oq_=faces_lH_.length-1-1|0;
                if(!(_oq_<_op_))
                 {var i_or_=_op_;
                  for(;;)
                   {var
                     _os_=faces_lH_[i_or_+1],
                     match_ot_=caml_array_get(_on_,_os_[1]),
                     y1_ou_=match_ot_[2],
                     x1_ov_=match_ot_[1],
                     match_ow_=caml_array_get(_on_,_os_[2]),
                     y2_ox_=match_ow_[2],
                     x2_oy_=match_ow_[1],
                     match_oz_=caml_array_get(_on_,_os_[3]),
                     y3_oA_=match_oz_[2],
                     x3_oB_=match_oz_[1],
                     _oC_=caml_array_get(normals_nr_,i_or_);
                    if(0<=_oC_[1]*_oo_[1]+_oC_[2]*_oo_[2]+_oC_[3]*_oo_[3])
                     {ctx__mu_.beginPath();
                      ctx__mu_.moveTo(x1_ov_,y1_ou_);
                      ctx__mu_.lineTo(x2_oy_,y2_ox_);
                      ctx__mu_.lineTo(x3_oB_,y3_oA_);
                      ctx__mu_.closePath();
                      ctx__mu_.save();
                      ctx__mu_.clip();
                      var
                       match_oD_=caml_array_get(face_info_nx_,i_or_),
                       dv_oE_=match_oD_[10],
                       du_oF_=match_oD_[9],
                       v_oG_=match_oD_[8],
                       u_oH_=match_oD_[7],
                       dv3_oI_=match_oD_[6],
                       du3_oJ_=match_oD_[5],
                       dv2_oK_=match_oD_[4],
                       du2_oL_=match_oD_[3],
                       v1_oM_=match_oD_[2],
                       u1_oN_=match_oD_[1],
                       dx2_oO_=x2_oy_-x1_ov_,
                       dx3_oP_=x3_oB_-x1_ov_,
                       dy2_oQ_=y2_ox_-y1_ou_,
                       dy3_oR_=y3_oA_-y1_ou_,
                       a_oS_=dx2_oO_*dv3_oI_-dx3_oP_*dv2_oK_,
                       b_oT_=dx2_oO_*du3_oJ_-dx3_oP_*du2_oL_,
                       d_oU_=dy2_oQ_*dv3_oI_-dy3_oR_*dv2_oK_,
                       e_oV_=dy2_oQ_*du3_oJ_-dy3_oR_*du2_oL_;
                      ctx__mu_.transform
                       (a_oS_,
                        d_oU_,
                        b_oT_,
                        e_oV_,
                        x1_ov_-a_oS_*u1_oN_-b_oT_*v1_oM_,
                        y1_ou_-d_oU_*u1_oN_-e_oV_*v1_oM_);
                      ctx__mu_.drawImage
                       (canvas__mo_,
                        u_oH_,
                        v_oG_,
                        du_oF_,
                        dv_oE_,
                        u_oH_,
                        v_oG_,
                        du_oF_,
                        dv_oE_);
                      ctx__mu_.restore();}
                    var _oW_=i_or_+1|0;
                    if(_oq_!==i_or_){var i_or_=_oW_;continue;}
                    break;}}
                ctx__mu_.restore();
                ctx_mt_.globalCompositeOperation=_F_.toString();
                ctx_mt_.drawImage(canvas__ms_,0,0);
                try {ctx_mt_.getImageData(0,0,1,1);}catch(_pn_){}
                var
                 t__oX_=new date_constr_jk_().getTime(),
                 hz_oY_=1000/(t__oX_-ti_of_[1]),
                 _oZ_=fps_og_[1]==0?hz_oY_:0.9*fps_og_[1]+0.1*hz_oY_;
                fps_og_[1]=_oZ_;
                rateText_nB_.data=_dl_(_hd_,_E_,fps_og_[1]).toString();
                ti_of_[1]=t__oX_;
                function _o__(param_o8_)
                 {var
                   t__o0_=new date_constr_jk_().getTime(),
                   dt_o2_=t__o0_-t_o1_,
                   dt_o3_=dt_o2_<0?0:1000<dt_o2_?0:dt_o2_,
                   angle_o4_=2*pi_kq_*dt_o3_/1000/10,
                   _o5_=
                    paused_ns_[1]
                     ?0
                     :follow_nt_[1]?(phi_rot_nA_[1]=phi_rot_nA_[1]+angle_o4_,1):0;
                  _o5_;
                  var _o6_=paused_ns_[1]?phi_oh_:phi_oh_+angle_o4_;
                  return loop_o7_(t__o0_,_o6_);}
                var
                 match_o9_=task_iO_(0),
                 t_o$_=match_o9_[1],
                 w_pa_=match_o9_[2],
                 _pc_=0.01*1000,
                 id_pd_=
                  window_jU_.setTimeout
                   (caml_js_wrap_callback
                     (function(param_pb_){return wakeup_iN_(w_pa_,0);}),
                    _pc_);
                function _pf_(param_pe_)
                 {return window_jU_.clearTimeout(id_pd_);}
                var _pg_=repr_ik_(t_o$_)[1];
                switch(_pg_[0])
                 {case 1:
                   var _ph_=_pg_[1][1]===Canceled_hu_?(_pf_(0),1):0;break;
                  case 2:
                   var sleeper_pm_=_pg_[1],data_pj_=current_data_hv_[1];
                   add_immutable_waiter_iM_
                    (sleeper_pm_,
                     function(param_pi_)
                      {if(1===param_pi_[0]&&param_pi_[1][1]===Canceled_hu_)
                        {current_data_hv_[1]=data_pj_;
                         try {var _pk_=_pf_(0);}catch(_pl_){return 0;}
                         return _pk_;}
                       return 0;});
                   var _ph_=1;
                   break;
                  default:var _ph_=0;}
                _ph_;
                return bind_iP_(t_o$_,_o__);};
            return loop_o7_(new date_constr_jk_().getTime(),0);}}
        var _po_=unsafeCreateElement_kh_(document_jV_,_Z_);
        function _ps_(param_pq_){return [0,[0,_po_]];}
        var match_pr_=task_iO_(0),w_pu_=match_pr_[2],t_pv_=match_pr_[1];
        function cont_pw_(x_pt_){return wakeup_iN_(w_pu_,x_pt_);}
        _po_.onload=
        handler_jN_(function(param_px_){cont_pw_(0);return _false_ji_;});
        _po_.src=texture_py_;
        var _pz_=repr_ik_(bind_iP_(bind_iP_(t_pv_,_ps_),_pp_))[1];
        switch(_pz_[0])
         {case 1:throw _pz_[1];
          case 2:
           var sleeper_pB_=_pz_[1];
           add_immutable_waiter_iM_
            (sleeper_pB_,
             function(param_pA_)
              {switch(param_pA_[0])
                {case 0:return 0;
                 case 1:throw param_pA_[1];
                 default:throw [0,_d_,_ah_];}});
           break;
          case 3:throw [0,_d_,_ag_];
          default:}
        return _false_ji_;});
    do_at_exit_a6_(0);
    return;}
  ());
